import { ConnectedSocket, MessageBody, OnGatewayConnection, OnGatewayDisconnect, SubscribeMessage, WebSocketGateway, WebSocketServer, WsResponse, } from '@nestjs/websockets';
import { from, Observable } from 'rxjs';
import { map } from 'rxjs/operators';
import { Server, Socket } from 'socket.io';

@WebSocketGateway({
    cors: {
        origin: '*',
    },
    namespace: `Sample-App`
})
export class SampleEventsGateway implements OnGatewayConnection, OnGatewayDisconnect {
    @WebSocketServer()
    server: Server;

    constructor() {
        // logic here
        // console.log(`Socket Server started??`)
    }

    @SubscribeMessage('test')
    test(@MessageBody() data: any, @ConnectedSocket() client: Socket): Observable<WsResponse<any>> {
        throw new Error(`Method not implemented`)
    }

    @SubscribeMessage('message')
    handleMesage(@MessageBody() data: string, @ConnectedSocket() client: Socket): void {
        console.log(data)
        console.log(`${data} from ${client.id}`)
    }

    // this two methods are non essential. as they are used to keep track of the local ui port 3000, not keeping track of the actual clients 
    handleConnection(client: any) {
        console.log('Monitoring UI connected:', client.id);
    }

    handleDisconnect(client: any) {
        console.log('Monitoring UI disconnected:', client.id);
    }
}